// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from foros_msgs:srv/AppendEntries.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__STRUCT_HPP_
#define FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__foros_msgs__srv__AppendEntries_Request __attribute__((deprecated))
#else
# define DEPRECATED__foros_msgs__srv__AppendEntries_Request __declspec(deprecated)
#endif

namespace foros_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AppendEntries_Request_
{
  using Type = AppendEntries_Request_<ContainerAllocator>;

  explicit AppendEntries_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->leader_id = 0ul;
      this->prev_log_index = 0ull;
      this->prev_log_term = 0ull;
      this->leader_commit = 0ull;
    }
  }

  explicit AppendEntries_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->leader_id = 0ul;
      this->prev_log_index = 0ull;
      this->prev_log_term = 0ull;
      this->leader_commit = 0ull;
    }
  }

  // field types and members
  using _term_type =
    uint64_t;
  _term_type term;
  using _leader_id_type =
    uint32_t;
  _leader_id_type leader_id;
  using _prev_log_index_type =
    uint64_t;
  _prev_log_index_type prev_log_index;
  using _prev_log_term_type =
    uint64_t;
  _prev_log_term_type prev_log_term;
  using _entries_type =
    std::vector<unsigned char, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<unsigned char>>;
  _entries_type entries;
  using _leader_commit_type =
    uint64_t;
  _leader_commit_type leader_commit;

  // setters for named parameter idiom
  Type & set__term(
    const uint64_t & _arg)
  {
    this->term = _arg;
    return *this;
  }
  Type & set__leader_id(
    const uint32_t & _arg)
  {
    this->leader_id = _arg;
    return *this;
  }
  Type & set__prev_log_index(
    const uint64_t & _arg)
  {
    this->prev_log_index = _arg;
    return *this;
  }
  Type & set__prev_log_term(
    const uint64_t & _arg)
  {
    this->prev_log_term = _arg;
    return *this;
  }
  Type & set__entries(
    const std::vector<unsigned char, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<unsigned char>> & _arg)
  {
    this->entries = _arg;
    return *this;
  }
  Type & set__leader_commit(
    const uint64_t & _arg)
  {
    this->leader_commit = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    foros_msgs::srv::AppendEntries_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const foros_msgs::srv::AppendEntries_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::AppendEntries_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::AppendEntries_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__foros_msgs__srv__AppendEntries_Request
    std::shared_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__foros_msgs__srv__AppendEntries_Request
    std::shared_ptr<foros_msgs::srv::AppendEntries_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AppendEntries_Request_ & other) const
  {
    if (this->term != other.term) {
      return false;
    }
    if (this->leader_id != other.leader_id) {
      return false;
    }
    if (this->prev_log_index != other.prev_log_index) {
      return false;
    }
    if (this->prev_log_term != other.prev_log_term) {
      return false;
    }
    if (this->entries != other.entries) {
      return false;
    }
    if (this->leader_commit != other.leader_commit) {
      return false;
    }
    return true;
  }
  bool operator!=(const AppendEntries_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AppendEntries_Request_

// alias to use template instance with default allocator
using AppendEntries_Request =
  foros_msgs::srv::AppendEntries_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace foros_msgs


#ifndef _WIN32
# define DEPRECATED__foros_msgs__srv__AppendEntries_Response __attribute__((deprecated))
#else
# define DEPRECATED__foros_msgs__srv__AppendEntries_Response __declspec(deprecated)
#endif

namespace foros_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AppendEntries_Response_
{
  using Type = AppendEntries_Response_<ContainerAllocator>;

  explicit AppendEntries_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->success = false;
    }
  }

  explicit AppendEntries_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->success = false;
    }
  }

  // field types and members
  using _term_type =
    uint64_t;
  _term_type term;
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__term(
    const uint64_t & _arg)
  {
    this->term = _arg;
    return *this;
  }
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    foros_msgs::srv::AppendEntries_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const foros_msgs::srv::AppendEntries_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::AppendEntries_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::AppendEntries_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__foros_msgs__srv__AppendEntries_Response
    std::shared_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__foros_msgs__srv__AppendEntries_Response
    std::shared_ptr<foros_msgs::srv::AppendEntries_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AppendEntries_Response_ & other) const
  {
    if (this->term != other.term) {
      return false;
    }
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const AppendEntries_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AppendEntries_Response_

// alias to use template instance with default allocator
using AppendEntries_Response =
  foros_msgs::srv::AppendEntries_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace foros_msgs

namespace foros_msgs
{

namespace srv
{

struct AppendEntries
{
  using Request = foros_msgs::srv::AppendEntries_Request;
  using Response = foros_msgs::srv::AppendEntries_Response;
};

}  // namespace srv

}  // namespace foros_msgs

#endif  // FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__STRUCT_HPP_
